// Code generated - DO NOT EDIT.
// This file is a generated binding and any manual changes will be lost.

package contracts

import (
	"errors"
	"math/big"
	"strings"

	ethereum "github.com/ethereum/go-ethereum"
	"github.com/ethereum/go-ethereum/accounts/abi"
	"github.com/ethereum/go-ethereum/accounts/abi/bind"
	"github.com/ethereum/go-ethereum/common"
	"github.com/ethereum/go-ethereum/core/types"
	"github.com/ethereum/go-ethereum/event"
)

// Reference imports to suppress errors if they are not otherwise used.
var (
	_ = errors.New
	_ = big.NewInt
	_ = strings.NewReader
	_ = ethereum.NotFound
	_ = bind.Bind
	_ = common.Big1
	_ = types.BloomLookup
	_ = event.NewSubscription
)

// IncentivesControllerMetaData contains all meta data concerning the IncentivesController contract.
var IncentivesControllerMetaData = &bind.MetaData{
	ABI: "[{\"inputs\":[{\"internalType\":\"address[]\",\"name\":\"assets\",\"type\":\"address[]\"},{\"internalType\":\"uint256\",\"name\":\"amount\",\"type\":\"uint256\"},{\"internalType\":\"address\",\"name\":\"to\",\"type\":\"address\"}],\"name\":\"claimRewards\",\"outputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"address[]\",\"name\":\"assets\",\"type\":\"address[]\"},{\"internalType\":\"address\",\"name\":\"user\",\"type\":\"address\"}],\"name\":\"getRewardsBalance\",\"outputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"stateMutability\":\"view\",\"type\":\"function\"}]",
}

// IncentivesControllerABI is the input ABI used to generate the binding from.
// Deprecated: Use IncentivesControllerMetaData.ABI instead.
var IncentivesControllerABI = IncentivesControllerMetaData.ABI

// IncentivesController is an auto generated Go binding around an Ethereum contract.
type IncentivesController struct {
	IncentivesControllerCaller     // Read-only binding to the contract
	IncentivesControllerTransactor // Write-only binding to the contract
	IncentivesControllerFilterer   // Log filterer for contract events
}

// IncentivesControllerCaller is an auto generated read-only Go binding around an Ethereum contract.
type IncentivesControllerCaller struct {
	contract *bind.BoundContract // Generic contract wrapper for the low level calls
}

// IncentivesControllerTransactor is an auto generated write-only Go binding around an Ethereum contract.
type IncentivesControllerTransactor struct {
	contract *bind.BoundContract // Generic contract wrapper for the low level calls
}

// IncentivesControllerFilterer is an auto generated log filtering Go binding around an Ethereum contract events.
type IncentivesControllerFilterer struct {
	contract *bind.BoundContract // Generic contract wrapper for the low level calls
}

// IncentivesControllerSession is an auto generated Go binding around an Ethereum contract,
// with pre-set call and transact options.
type IncentivesControllerSession struct {
	Contract     *IncentivesController // Generic contract binding to set the session for
	CallOpts     bind.CallOpts         // Call options to use throughout this session
	TransactOpts bind.TransactOpts     // Transaction auth options to use throughout this session
}

// IncentivesControllerCallerSession is an auto generated read-only Go binding around an Ethereum contract,
// with pre-set call options.
type IncentivesControllerCallerSession struct {
	Contract *IncentivesControllerCaller // Generic contract caller binding to set the session for
	CallOpts bind.CallOpts               // Call options to use throughout this session
}

// IncentivesControllerTransactorSession is an auto generated write-only Go binding around an Ethereum contract,
// with pre-set transact options.
type IncentivesControllerTransactorSession struct {
	Contract     *IncentivesControllerTransactor // Generic contract transactor binding to set the session for
	TransactOpts bind.TransactOpts               // Transaction auth options to use throughout this session
}

// IncentivesControllerRaw is an auto generated low-level Go binding around an Ethereum contract.
type IncentivesControllerRaw struct {
	Contract *IncentivesController // Generic contract binding to access the raw methods on
}

// IncentivesControllerCallerRaw is an auto generated low-level read-only Go binding around an Ethereum contract.
type IncentivesControllerCallerRaw struct {
	Contract *IncentivesControllerCaller // Generic read-only contract binding to access the raw methods on
}

// IncentivesControllerTransactorRaw is an auto generated low-level write-only Go binding around an Ethereum contract.
type IncentivesControllerTransactorRaw struct {
	Contract *IncentivesControllerTransactor // Generic write-only contract binding to access the raw methods on
}

// NewIncentivesController creates a new instance of IncentivesController, bound to a specific deployed contract.
func NewIncentivesController(address common.Address, backend bind.ContractBackend) (*IncentivesController, error) {
	contract, err := bindIncentivesController(address, backend, backend, backend)
	if err != nil {
		return nil, err
	}
	return &IncentivesController{IncentivesControllerCaller: IncentivesControllerCaller{contract: contract}, IncentivesControllerTransactor: IncentivesControllerTransactor{contract: contract}, IncentivesControllerFilterer: IncentivesControllerFilterer{contract: contract}}, nil
}

// NewIncentivesControllerCaller creates a new read-only instance of IncentivesController, bound to a specific deployed contract.
func NewIncentivesControllerCaller(address common.Address, caller bind.ContractCaller) (*IncentivesControllerCaller, error) {
	contract, err := bindIncentivesController(address, caller, nil, nil)
	if err != nil {
		return nil, err
	}
	return &IncentivesControllerCaller{contract: contract}, nil
}

// NewIncentivesControllerTransactor creates a new write-only instance of IncentivesController, bound to a specific deployed contract.
func NewIncentivesControllerTransactor(address common.Address, transactor bind.ContractTransactor) (*IncentivesControllerTransactor, error) {
	contract, err := bindIncentivesController(address, nil, transactor, nil)
	if err != nil {
		return nil, err
	}
	return &IncentivesControllerTransactor{contract: contract}, nil
}

// NewIncentivesControllerFilterer creates a new log filterer instance of IncentivesController, bound to a specific deployed contract.
func NewIncentivesControllerFilterer(address common.Address, filterer bind.ContractFilterer) (*IncentivesControllerFilterer, error) {
	contract, err := bindIncentivesController(address, nil, nil, filterer)
	if err != nil {
		return nil, err
	}
	return &IncentivesControllerFilterer{contract: contract}, nil
}

// bindIncentivesController binds a generic wrapper to an already deployed contract.
func bindIncentivesController(address common.Address, caller bind.ContractCaller, transactor bind.ContractTransactor, filterer bind.ContractFilterer) (*bind.BoundContract, error) {
	parsed, err := abi.JSON(strings.NewReader(IncentivesControllerABI))
	if err != nil {
		return nil, err
	}
	return bind.NewBoundContract(address, parsed, caller, transactor, filterer), nil
}

// Call invokes the (constant) contract method with params as input values and
// sets the output to result. The result type might be a single field for simple
// returns, a slice of interfaces for anonymous returns and a struct for named
// returns.
func (_IncentivesController *IncentivesControllerRaw) Call(opts *bind.CallOpts, result *[]interface{}, method string, params ...interface{}) error {
	return _IncentivesController.Contract.IncentivesControllerCaller.contract.Call(opts, result, method, params...)
}

// Transfer initiates a plain transaction to move funds to the contract, calling
// its default method if one is available.
func (_IncentivesController *IncentivesControllerRaw) Transfer(opts *bind.TransactOpts) (*types.Transaction, error) {
	return _IncentivesController.Contract.IncentivesControllerTransactor.contract.Transfer(opts)
}

// Transact invokes the (paid) contract method with params as input values.
func (_IncentivesController *IncentivesControllerRaw) Transact(opts *bind.TransactOpts, method string, params ...interface{}) (*types.Transaction, error) {
	return _IncentivesController.Contract.IncentivesControllerTransactor.contract.Transact(opts, method, params...)
}

// Call invokes the (constant) contract method with params as input values and
// sets the output to result. The result type might be a single field for simple
// returns, a slice of interfaces for anonymous returns and a struct for named
// returns.
func (_IncentivesController *IncentivesControllerCallerRaw) Call(opts *bind.CallOpts, result *[]interface{}, method string, params ...interface{}) error {
	return _IncentivesController.Contract.contract.Call(opts, result, method, params...)
}

// Transfer initiates a plain transaction to move funds to the contract, calling
// its default method if one is available.
func (_IncentivesController *IncentivesControllerTransactorRaw) Transfer(opts *bind.TransactOpts) (*types.Transaction, error) {
	return _IncentivesController.Contract.contract.Transfer(opts)
}

// Transact invokes the (paid) contract method with params as input values.
func (_IncentivesController *IncentivesControllerTransactorRaw) Transact(opts *bind.TransactOpts, method string, params ...interface{}) (*types.Transaction, error) {
	return _IncentivesController.Contract.contract.Transact(opts, method, params...)
}

// GetRewardsBalance is a free data retrieval call binding the contract method 0x8b599f26.
//
// Solidity: function getRewardsBalance(address[] assets, address user) view returns(uint256)
func (_IncentivesController *IncentivesControllerCaller) GetRewardsBalance(opts *bind.CallOpts, assets []common.Address, user common.Address) (*big.Int, error) {
	var out []interface{}
	err := _IncentivesController.contract.Call(opts, &out, "getRewardsBalance", assets, user)

	if err != nil {
		return *new(*big.Int), err
	}

	out0 := *abi.ConvertType(out[0], new(*big.Int)).(**big.Int)

	return out0, err

}

// GetRewardsBalance is a free data retrieval call binding the contract method 0x8b599f26.
//
// Solidity: function getRewardsBalance(address[] assets, address user) view returns(uint256)
func (_IncentivesController *IncentivesControllerSession) GetRewardsBalance(assets []common.Address, user common.Address) (*big.Int, error) {
	return _IncentivesController.Contract.GetRewardsBalance(&_IncentivesController.CallOpts, assets, user)
}

// GetRewardsBalance is a free data retrieval call binding the contract method 0x8b599f26.
//
// Solidity: function getRewardsBalance(address[] assets, address user) view returns(uint256)
func (_IncentivesController *IncentivesControllerCallerSession) GetRewardsBalance(assets []common.Address, user common.Address) (*big.Int, error) {
	return _IncentivesController.Contract.GetRewardsBalance(&_IncentivesController.CallOpts, assets, user)
}

// ClaimRewards is a paid mutator transaction binding the contract method 0x3111e7b3.
//
// Solidity: function claimRewards(address[] assets, uint256 amount, address to) returns(uint256)
func (_IncentivesController *IncentivesControllerTransactor) ClaimRewards(opts *bind.TransactOpts, assets []common.Address, amount *big.Int, to common.Address) (*types.Transaction, error) {
	return _IncentivesController.contract.Transact(opts, "claimRewards", assets, amount, to)
}

// ClaimRewards is a paid mutator transaction binding the contract method 0x3111e7b3.
//
// Solidity: function claimRewards(address[] assets, uint256 amount, address to) returns(uint256)
func (_IncentivesController *IncentivesControllerSession) ClaimRewards(assets []common.Address, amount *big.Int, to common.Address) (*types.Transaction, error) {
	return _IncentivesController.Contract.ClaimRewards(&_IncentivesController.TransactOpts, assets, amount, to)
}

// ClaimRewards is a paid mutator transaction binding the contract method 0x3111e7b3.
//
// Solidity: function claimRewards(address[] assets, uint256 amount, address to) returns(uint256)
func (_IncentivesController *IncentivesControllerTransactorSession) ClaimRewards(assets []common.Address, amount *big.Int, to common.Address) (*types.Transaction, error) {
	return _IncentivesController.Contract.ClaimRewards(&_IncentivesController.TransactOpts, assets, amount, to)
}
