// Code generated - DO NOT EDIT.
// This file is a generated binding and any manual changes will be lost.

package contracts

import (
	"errors"
	"math/big"
	"strings"

	ethereum "github.com/ethereum/go-ethereum"
	"github.com/ethereum/go-ethereum/accounts/abi"
	"github.com/ethereum/go-ethereum/accounts/abi/bind"
	"github.com/ethereum/go-ethereum/common"
	"github.com/ethereum/go-ethereum/core/types"
	"github.com/ethereum/go-ethereum/event"
)

// Reference imports to suppress errors if they are not otherwise used.
var (
	_ = errors.New
	_ = big.NewInt
	_ = strings.NewReader
	_ = ethereum.NotFound
	_ = bind.Bind
	_ = common.Big1
	_ = types.BloomLookup
	_ = event.NewSubscription
)

// VaultV6MetaData contains all meta data concerning the VaultV6 contract.
var VaultV6MetaData = &bind.MetaData{
	ABI: "[{\"inputs\":[{\"internalType\":\"contractIStrategy\",\"name\":\"_strategy\",\"type\":\"address\"},{\"internalType\":\"string\",\"name\":\"_name\",\"type\":\"string\"},{\"internalType\":\"string\",\"name\":\"_symbol\",\"type\":\"string\"},{\"internalType\":\"uint256\",\"name\":\"_approvalDelay\",\"type\":\"uint256\"}],\"stateMutability\":\"nonpayable\",\"type\":\"constructor\"},{\"anonymous\":false,\"inputs\":[{\"indexed\":true,\"internalType\":\"address\",\"name\":\"owner\",\"type\":\"address\"},{\"indexed\":true,\"internalType\":\"address\",\"name\":\"spender\",\"type\":\"address\"},{\"indexed\":false,\"internalType\":\"uint256\",\"name\":\"value\",\"type\":\"uint256\"}],\"name\":\"Approval\",\"type\":\"event\"},{\"anonymous\":false,\"inputs\":[{\"indexed\":false,\"internalType\":\"address\",\"name\":\"implementation\",\"type\":\"address\"}],\"name\":\"NewStratCandidate\",\"type\":\"event\"},{\"anonymous\":false,\"inputs\":[{\"indexed\":true,\"internalType\":\"address\",\"name\":\"previousOwner\",\"type\":\"address\"},{\"indexed\":true,\"internalType\":\"address\",\"name\":\"newOwner\",\"type\":\"address\"}],\"name\":\"OwnershipTransferred\",\"type\":\"event\"},{\"anonymous\":false,\"inputs\":[{\"indexed\":true,\"internalType\":\"address\",\"name\":\"from\",\"type\":\"address\"},{\"indexed\":true,\"internalType\":\"address\",\"name\":\"to\",\"type\":\"address\"},{\"indexed\":false,\"internalType\":\"uint256\",\"name\":\"value\",\"type\":\"uint256\"}],\"name\":\"Transfer\",\"type\":\"event\"},{\"anonymous\":false,\"inputs\":[{\"indexed\":false,\"internalType\":\"address\",\"name\":\"implementation\",\"type\":\"address\"}],\"name\":\"UpgradeStrat\",\"type\":\"event\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"owner\",\"type\":\"address\"},{\"internalType\":\"address\",\"name\":\"spender\",\"type\":\"address\"}],\"name\":\"allowance\",\"outputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"approvalDelay\",\"outputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"spender\",\"type\":\"address\"},{\"internalType\":\"uint256\",\"name\":\"amount\",\"type\":\"uint256\"}],\"name\":\"approve\",\"outputs\":[{\"internalType\":\"bool\",\"name\":\"\",\"type\":\"bool\"}],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"available\",\"outputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"balance\",\"outputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"account\",\"type\":\"address\"}],\"name\":\"balanceOf\",\"outputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"decimals\",\"outputs\":[{\"internalType\":\"uint8\",\"name\":\"\",\"type\":\"uint8\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"spender\",\"type\":\"address\"},{\"internalType\":\"uint256\",\"name\":\"subtractedValue\",\"type\":\"uint256\"}],\"name\":\"decreaseAllowance\",\"outputs\":[{\"internalType\":\"bool\",\"name\":\"\",\"type\":\"bool\"}],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"uint256\",\"name\":\"_amount\",\"type\":\"uint256\"}],\"name\":\"deposit\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"depositAll\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"earn\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"getPricePerFullShare\",\"outputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"_token\",\"type\":\"address\"}],\"name\":\"inCaseTokensGetStuck\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"spender\",\"type\":\"address\"},{\"internalType\":\"uint256\",\"name\":\"addedValue\",\"type\":\"uint256\"}],\"name\":\"increaseAllowance\",\"outputs\":[{\"internalType\":\"bool\",\"name\":\"\",\"type\":\"bool\"}],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"name\",\"outputs\":[{\"internalType\":\"string\",\"name\":\"\",\"type\":\"string\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"owner\",\"outputs\":[{\"internalType\":\"address\",\"name\":\"\",\"type\":\"address\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"_implementation\",\"type\":\"address\"}],\"name\":\"proposeStrat\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"renounceOwnership\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"stratCandidate\",\"outputs\":[{\"internalType\":\"address\",\"name\":\"implementation\",\"type\":\"address\"},{\"internalType\":\"uint256\",\"name\":\"proposedTime\",\"type\":\"uint256\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"strategy\",\"outputs\":[{\"internalType\":\"contractIStrategy\",\"name\":\"\",\"type\":\"address\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"symbol\",\"outputs\":[{\"internalType\":\"string\",\"name\":\"\",\"type\":\"string\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"totalSupply\",\"outputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"recipient\",\"type\":\"address\"},{\"internalType\":\"uint256\",\"name\":\"amount\",\"type\":\"uint256\"}],\"name\":\"transfer\",\"outputs\":[{\"internalType\":\"bool\",\"name\":\"\",\"type\":\"bool\"}],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"sender\",\"type\":\"address\"},{\"internalType\":\"address\",\"name\":\"recipient\",\"type\":\"address\"},{\"internalType\":\"uint256\",\"name\":\"amount\",\"type\":\"uint256\"}],\"name\":\"transferFrom\",\"outputs\":[{\"internalType\":\"bool\",\"name\":\"\",\"type\":\"bool\"}],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"newOwner\",\"type\":\"address\"}],\"name\":\"transferOwnership\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"upgradeStrat\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"want\",\"outputs\":[{\"internalType\":\"contractIERC20\",\"name\":\"\",\"type\":\"address\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"uint256\",\"name\":\"_shares\",\"type\":\"uint256\"}],\"name\":\"withdraw\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"withdrawAll\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"}]",
}

// VaultV6ABI is the input ABI used to generate the binding from.
// Deprecated: Use VaultV6MetaData.ABI instead.
var VaultV6ABI = VaultV6MetaData.ABI

// VaultV6 is an auto generated Go binding around an Ethereum contract.
type VaultV6 struct {
	VaultV6Caller     // Read-only binding to the contract
	VaultV6Transactor // Write-only binding to the contract
	VaultV6Filterer   // Log filterer for contract events
}

// VaultV6Caller is an auto generated read-only Go binding around an Ethereum contract.
type VaultV6Caller struct {
	contract *bind.BoundContract // Generic contract wrapper for the low level calls
}

// VaultV6Transactor is an auto generated write-only Go binding around an Ethereum contract.
type VaultV6Transactor struct {
	contract *bind.BoundContract // Generic contract wrapper for the low level calls
}

// VaultV6Filterer is an auto generated log filtering Go binding around an Ethereum contract events.
type VaultV6Filterer struct {
	contract *bind.BoundContract // Generic contract wrapper for the low level calls
}

// VaultV6Session is an auto generated Go binding around an Ethereum contract,
// with pre-set call and transact options.
type VaultV6Session struct {
	Contract     *VaultV6          // Generic contract binding to set the session for
	CallOpts     bind.CallOpts     // Call options to use throughout this session
	TransactOpts bind.TransactOpts // Transaction auth options to use throughout this session
}

// VaultV6CallerSession is an auto generated read-only Go binding around an Ethereum contract,
// with pre-set call options.
type VaultV6CallerSession struct {
	Contract *VaultV6Caller // Generic contract caller binding to set the session for
	CallOpts bind.CallOpts  // Call options to use throughout this session
}

// VaultV6TransactorSession is an auto generated write-only Go binding around an Ethereum contract,
// with pre-set transact options.
type VaultV6TransactorSession struct {
	Contract     *VaultV6Transactor // Generic contract transactor binding to set the session for
	TransactOpts bind.TransactOpts  // Transaction auth options to use throughout this session
}

// VaultV6Raw is an auto generated low-level Go binding around an Ethereum contract.
type VaultV6Raw struct {
	Contract *VaultV6 // Generic contract binding to access the raw methods on
}

// VaultV6CallerRaw is an auto generated low-level read-only Go binding around an Ethereum contract.
type VaultV6CallerRaw struct {
	Contract *VaultV6Caller // Generic read-only contract binding to access the raw methods on
}

// VaultV6TransactorRaw is an auto generated low-level write-only Go binding around an Ethereum contract.
type VaultV6TransactorRaw struct {
	Contract *VaultV6Transactor // Generic write-only contract binding to access the raw methods on
}

// NewVaultV6 creates a new instance of VaultV6, bound to a specific deployed contract.
func NewVaultV6(address common.Address, backend bind.ContractBackend) (*VaultV6, error) {
	contract, err := bindVaultV6(address, backend, backend, backend)
	if err != nil {
		return nil, err
	}
	return &VaultV6{VaultV6Caller: VaultV6Caller{contract: contract}, VaultV6Transactor: VaultV6Transactor{contract: contract}, VaultV6Filterer: VaultV6Filterer{contract: contract}}, nil
}

// NewVaultV6Caller creates a new read-only instance of VaultV6, bound to a specific deployed contract.
func NewVaultV6Caller(address common.Address, caller bind.ContractCaller) (*VaultV6Caller, error) {
	contract, err := bindVaultV6(address, caller, nil, nil)
	if err != nil {
		return nil, err
	}
	return &VaultV6Caller{contract: contract}, nil
}

// NewVaultV6Transactor creates a new write-only instance of VaultV6, bound to a specific deployed contract.
func NewVaultV6Transactor(address common.Address, transactor bind.ContractTransactor) (*VaultV6Transactor, error) {
	contract, err := bindVaultV6(address, nil, transactor, nil)
	if err != nil {
		return nil, err
	}
	return &VaultV6Transactor{contract: contract}, nil
}

// NewVaultV6Filterer creates a new log filterer instance of VaultV6, bound to a specific deployed contract.
func NewVaultV6Filterer(address common.Address, filterer bind.ContractFilterer) (*VaultV6Filterer, error) {
	contract, err := bindVaultV6(address, nil, nil, filterer)
	if err != nil {
		return nil, err
	}
	return &VaultV6Filterer{contract: contract}, nil
}

// bindVaultV6 binds a generic wrapper to an already deployed contract.
func bindVaultV6(address common.Address, caller bind.ContractCaller, transactor bind.ContractTransactor, filterer bind.ContractFilterer) (*bind.BoundContract, error) {
	parsed, err := abi.JSON(strings.NewReader(VaultV6ABI))
	if err != nil {
		return nil, err
	}
	return bind.NewBoundContract(address, parsed, caller, transactor, filterer), nil
}

// Call invokes the (constant) contract method with params as input values and
// sets the output to result. The result type might be a single field for simple
// returns, a slice of interfaces for anonymous returns and a struct for named
// returns.
func (_VaultV6 *VaultV6Raw) Call(opts *bind.CallOpts, result *[]interface{}, method string, params ...interface{}) error {
	return _VaultV6.Contract.VaultV6Caller.contract.Call(opts, result, method, params...)
}

// Transfer initiates a plain transaction to move funds to the contract, calling
// its default method if one is available.
func (_VaultV6 *VaultV6Raw) Transfer(opts *bind.TransactOpts) (*types.Transaction, error) {
	return _VaultV6.Contract.VaultV6Transactor.contract.Transfer(opts)
}

// Transact invokes the (paid) contract method with params as input values.
func (_VaultV6 *VaultV6Raw) Transact(opts *bind.TransactOpts, method string, params ...interface{}) (*types.Transaction, error) {
	return _VaultV6.Contract.VaultV6Transactor.contract.Transact(opts, method, params...)
}

// Call invokes the (constant) contract method with params as input values and
// sets the output to result. The result type might be a single field for simple
// returns, a slice of interfaces for anonymous returns and a struct for named
// returns.
func (_VaultV6 *VaultV6CallerRaw) Call(opts *bind.CallOpts, result *[]interface{}, method string, params ...interface{}) error {
	return _VaultV6.Contract.contract.Call(opts, result, method, params...)
}

// Transfer initiates a plain transaction to move funds to the contract, calling
// its default method if one is available.
func (_VaultV6 *VaultV6TransactorRaw) Transfer(opts *bind.TransactOpts) (*types.Transaction, error) {
	return _VaultV6.Contract.contract.Transfer(opts)
}

// Transact invokes the (paid) contract method with params as input values.
func (_VaultV6 *VaultV6TransactorRaw) Transact(opts *bind.TransactOpts, method string, params ...interface{}) (*types.Transaction, error) {
	return _VaultV6.Contract.contract.Transact(opts, method, params...)
}

// Allowance is a free data retrieval call binding the contract method 0xdd62ed3e.
//
// Solidity: function allowance(address owner, address spender) view returns(uint256)
func (_VaultV6 *VaultV6Caller) Allowance(opts *bind.CallOpts, owner common.Address, spender common.Address) (*big.Int, error) {
	var out []interface{}
	err := _VaultV6.contract.Call(opts, &out, "allowance", owner, spender)

	if err != nil {
		return *new(*big.Int), err
	}

	out0 := *abi.ConvertType(out[0], new(*big.Int)).(**big.Int)

	return out0, err

}

// Allowance is a free data retrieval call binding the contract method 0xdd62ed3e.
//
// Solidity: function allowance(address owner, address spender) view returns(uint256)
func (_VaultV6 *VaultV6Session) Allowance(owner common.Address, spender common.Address) (*big.Int, error) {
	return _VaultV6.Contract.Allowance(&_VaultV6.CallOpts, owner, spender)
}

// Allowance is a free data retrieval call binding the contract method 0xdd62ed3e.
//
// Solidity: function allowance(address owner, address spender) view returns(uint256)
func (_VaultV6 *VaultV6CallerSession) Allowance(owner common.Address, spender common.Address) (*big.Int, error) {
	return _VaultV6.Contract.Allowance(&_VaultV6.CallOpts, owner, spender)
}

// ApprovalDelay is a free data retrieval call binding the contract method 0xe2d1e75c.
//
// Solidity: function approvalDelay() view returns(uint256)
func (_VaultV6 *VaultV6Caller) ApprovalDelay(opts *bind.CallOpts) (*big.Int, error) {
	var out []interface{}
	err := _VaultV6.contract.Call(opts, &out, "approvalDelay")

	if err != nil {
		return *new(*big.Int), err
	}

	out0 := *abi.ConvertType(out[0], new(*big.Int)).(**big.Int)

	return out0, err

}

// ApprovalDelay is a free data retrieval call binding the contract method 0xe2d1e75c.
//
// Solidity: function approvalDelay() view returns(uint256)
func (_VaultV6 *VaultV6Session) ApprovalDelay() (*big.Int, error) {
	return _VaultV6.Contract.ApprovalDelay(&_VaultV6.CallOpts)
}

// ApprovalDelay is a free data retrieval call binding the contract method 0xe2d1e75c.
//
// Solidity: function approvalDelay() view returns(uint256)
func (_VaultV6 *VaultV6CallerSession) ApprovalDelay() (*big.Int, error) {
	return _VaultV6.Contract.ApprovalDelay(&_VaultV6.CallOpts)
}

// Available is a free data retrieval call binding the contract method 0x48a0d754.
//
// Solidity: function available() view returns(uint256)
func (_VaultV6 *VaultV6Caller) Available(opts *bind.CallOpts) (*big.Int, error) {
	var out []interface{}
	err := _VaultV6.contract.Call(opts, &out, "available")

	if err != nil {
		return *new(*big.Int), err
	}

	out0 := *abi.ConvertType(out[0], new(*big.Int)).(**big.Int)

	return out0, err

}

// Available is a free data retrieval call binding the contract method 0x48a0d754.
//
// Solidity: function available() view returns(uint256)
func (_VaultV6 *VaultV6Session) Available() (*big.Int, error) {
	return _VaultV6.Contract.Available(&_VaultV6.CallOpts)
}

// Available is a free data retrieval call binding the contract method 0x48a0d754.
//
// Solidity: function available() view returns(uint256)
func (_VaultV6 *VaultV6CallerSession) Available() (*big.Int, error) {
	return _VaultV6.Contract.Available(&_VaultV6.CallOpts)
}

// Balance is a free data retrieval call binding the contract method 0xb69ef8a8.
//
// Solidity: function balance() view returns(uint256)
func (_VaultV6 *VaultV6Caller) Balance(opts *bind.CallOpts) (*big.Int, error) {
	var out []interface{}
	err := _VaultV6.contract.Call(opts, &out, "balance")

	if err != nil {
		return *new(*big.Int), err
	}

	out0 := *abi.ConvertType(out[0], new(*big.Int)).(**big.Int)

	return out0, err

}

// Balance is a free data retrieval call binding the contract method 0xb69ef8a8.
//
// Solidity: function balance() view returns(uint256)
func (_VaultV6 *VaultV6Session) Balance() (*big.Int, error) {
	return _VaultV6.Contract.Balance(&_VaultV6.CallOpts)
}

// Balance is a free data retrieval call binding the contract method 0xb69ef8a8.
//
// Solidity: function balance() view returns(uint256)
func (_VaultV6 *VaultV6CallerSession) Balance() (*big.Int, error) {
	return _VaultV6.Contract.Balance(&_VaultV6.CallOpts)
}

// BalanceOf is a free data retrieval call binding the contract method 0x70a08231.
//
// Solidity: function balanceOf(address account) view returns(uint256)
func (_VaultV6 *VaultV6Caller) BalanceOf(opts *bind.CallOpts, account common.Address) (*big.Int, error) {
	var out []interface{}
	err := _VaultV6.contract.Call(opts, &out, "balanceOf", account)

	if err != nil {
		return *new(*big.Int), err
	}

	out0 := *abi.ConvertType(out[0], new(*big.Int)).(**big.Int)

	return out0, err

}

// BalanceOf is a free data retrieval call binding the contract method 0x70a08231.
//
// Solidity: function balanceOf(address account) view returns(uint256)
func (_VaultV6 *VaultV6Session) BalanceOf(account common.Address) (*big.Int, error) {
	return _VaultV6.Contract.BalanceOf(&_VaultV6.CallOpts, account)
}

// BalanceOf is a free data retrieval call binding the contract method 0x70a08231.
//
// Solidity: function balanceOf(address account) view returns(uint256)
func (_VaultV6 *VaultV6CallerSession) BalanceOf(account common.Address) (*big.Int, error) {
	return _VaultV6.Contract.BalanceOf(&_VaultV6.CallOpts, account)
}

// Decimals is a free data retrieval call binding the contract method 0x313ce567.
//
// Solidity: function decimals() view returns(uint8)
func (_VaultV6 *VaultV6Caller) Decimals(opts *bind.CallOpts) (uint8, error) {
	var out []interface{}
	err := _VaultV6.contract.Call(opts, &out, "decimals")

	if err != nil {
		return *new(uint8), err
	}

	out0 := *abi.ConvertType(out[0], new(uint8)).(*uint8)

	return out0, err

}

// Decimals is a free data retrieval call binding the contract method 0x313ce567.
//
// Solidity: function decimals() view returns(uint8)
func (_VaultV6 *VaultV6Session) Decimals() (uint8, error) {
	return _VaultV6.Contract.Decimals(&_VaultV6.CallOpts)
}

// Decimals is a free data retrieval call binding the contract method 0x313ce567.
//
// Solidity: function decimals() view returns(uint8)
func (_VaultV6 *VaultV6CallerSession) Decimals() (uint8, error) {
	return _VaultV6.Contract.Decimals(&_VaultV6.CallOpts)
}

// GetPricePerFullShare is a free data retrieval call binding the contract method 0x77c7b8fc.
//
// Solidity: function getPricePerFullShare() view returns(uint256)
func (_VaultV6 *VaultV6Caller) GetPricePerFullShare(opts *bind.CallOpts) (*big.Int, error) {
	var out []interface{}
	err := _VaultV6.contract.Call(opts, &out, "getPricePerFullShare")

	if err != nil {
		return *new(*big.Int), err
	}

	out0 := *abi.ConvertType(out[0], new(*big.Int)).(**big.Int)

	return out0, err

}

// GetPricePerFullShare is a free data retrieval call binding the contract method 0x77c7b8fc.
//
// Solidity: function getPricePerFullShare() view returns(uint256)
func (_VaultV6 *VaultV6Session) GetPricePerFullShare() (*big.Int, error) {
	return _VaultV6.Contract.GetPricePerFullShare(&_VaultV6.CallOpts)
}

// GetPricePerFullShare is a free data retrieval call binding the contract method 0x77c7b8fc.
//
// Solidity: function getPricePerFullShare() view returns(uint256)
func (_VaultV6 *VaultV6CallerSession) GetPricePerFullShare() (*big.Int, error) {
	return _VaultV6.Contract.GetPricePerFullShare(&_VaultV6.CallOpts)
}

// Name is a free data retrieval call binding the contract method 0x06fdde03.
//
// Solidity: function name() view returns(string)
func (_VaultV6 *VaultV6Caller) Name(opts *bind.CallOpts) (string, error) {
	var out []interface{}
	err := _VaultV6.contract.Call(opts, &out, "name")

	if err != nil {
		return *new(string), err
	}

	out0 := *abi.ConvertType(out[0], new(string)).(*string)

	return out0, err

}

// Name is a free data retrieval call binding the contract method 0x06fdde03.
//
// Solidity: function name() view returns(string)
func (_VaultV6 *VaultV6Session) Name() (string, error) {
	return _VaultV6.Contract.Name(&_VaultV6.CallOpts)
}

// Name is a free data retrieval call binding the contract method 0x06fdde03.
//
// Solidity: function name() view returns(string)
func (_VaultV6 *VaultV6CallerSession) Name() (string, error) {
	return _VaultV6.Contract.Name(&_VaultV6.CallOpts)
}

// Owner is a free data retrieval call binding the contract method 0x8da5cb5b.
//
// Solidity: function owner() view returns(address)
func (_VaultV6 *VaultV6Caller) Owner(opts *bind.CallOpts) (common.Address, error) {
	var out []interface{}
	err := _VaultV6.contract.Call(opts, &out, "owner")

	if err != nil {
		return *new(common.Address), err
	}

	out0 := *abi.ConvertType(out[0], new(common.Address)).(*common.Address)

	return out0, err

}

// Owner is a free data retrieval call binding the contract method 0x8da5cb5b.
//
// Solidity: function owner() view returns(address)
func (_VaultV6 *VaultV6Session) Owner() (common.Address, error) {
	return _VaultV6.Contract.Owner(&_VaultV6.CallOpts)
}

// Owner is a free data retrieval call binding the contract method 0x8da5cb5b.
//
// Solidity: function owner() view returns(address)
func (_VaultV6 *VaultV6CallerSession) Owner() (common.Address, error) {
	return _VaultV6.Contract.Owner(&_VaultV6.CallOpts)
}

// StratCandidate is a free data retrieval call binding the contract method 0x76dfabb8.
//
// Solidity: function stratCandidate() view returns(address implementation, uint256 proposedTime)
func (_VaultV6 *VaultV6Caller) StratCandidate(opts *bind.CallOpts) (struct {
	Implementation common.Address
	ProposedTime   *big.Int
}, error) {
	var out []interface{}
	err := _VaultV6.contract.Call(opts, &out, "stratCandidate")

	outstruct := new(struct {
		Implementation common.Address
		ProposedTime   *big.Int
	})
	if err != nil {
		return *outstruct, err
	}

	outstruct.Implementation = *abi.ConvertType(out[0], new(common.Address)).(*common.Address)
	outstruct.ProposedTime = *abi.ConvertType(out[1], new(*big.Int)).(**big.Int)

	return *outstruct, err

}

// StratCandidate is a free data retrieval call binding the contract method 0x76dfabb8.
//
// Solidity: function stratCandidate() view returns(address implementation, uint256 proposedTime)
func (_VaultV6 *VaultV6Session) StratCandidate() (struct {
	Implementation common.Address
	ProposedTime   *big.Int
}, error) {
	return _VaultV6.Contract.StratCandidate(&_VaultV6.CallOpts)
}

// StratCandidate is a free data retrieval call binding the contract method 0x76dfabb8.
//
// Solidity: function stratCandidate() view returns(address implementation, uint256 proposedTime)
func (_VaultV6 *VaultV6CallerSession) StratCandidate() (struct {
	Implementation common.Address
	ProposedTime   *big.Int
}, error) {
	return _VaultV6.Contract.StratCandidate(&_VaultV6.CallOpts)
}

// Strategy is a free data retrieval call binding the contract method 0xa8c62e76.
//
// Solidity: function strategy() view returns(address)
func (_VaultV6 *VaultV6Caller) Strategy(opts *bind.CallOpts) (common.Address, error) {
	var out []interface{}
	err := _VaultV6.contract.Call(opts, &out, "strategy")

	if err != nil {
		return *new(common.Address), err
	}

	out0 := *abi.ConvertType(out[0], new(common.Address)).(*common.Address)

	return out0, err

}

// Strategy is a free data retrieval call binding the contract method 0xa8c62e76.
//
// Solidity: function strategy() view returns(address)
func (_VaultV6 *VaultV6Session) Strategy() (common.Address, error) {
	return _VaultV6.Contract.Strategy(&_VaultV6.CallOpts)
}

// Strategy is a free data retrieval call binding the contract method 0xa8c62e76.
//
// Solidity: function strategy() view returns(address)
func (_VaultV6 *VaultV6CallerSession) Strategy() (common.Address, error) {
	return _VaultV6.Contract.Strategy(&_VaultV6.CallOpts)
}

// Symbol is a free data retrieval call binding the contract method 0x95d89b41.
//
// Solidity: function symbol() view returns(string)
func (_VaultV6 *VaultV6Caller) Symbol(opts *bind.CallOpts) (string, error) {
	var out []interface{}
	err := _VaultV6.contract.Call(opts, &out, "symbol")

	if err != nil {
		return *new(string), err
	}

	out0 := *abi.ConvertType(out[0], new(string)).(*string)

	return out0, err

}

// Symbol is a free data retrieval call binding the contract method 0x95d89b41.
//
// Solidity: function symbol() view returns(string)
func (_VaultV6 *VaultV6Session) Symbol() (string, error) {
	return _VaultV6.Contract.Symbol(&_VaultV6.CallOpts)
}

// Symbol is a free data retrieval call binding the contract method 0x95d89b41.
//
// Solidity: function symbol() view returns(string)
func (_VaultV6 *VaultV6CallerSession) Symbol() (string, error) {
	return _VaultV6.Contract.Symbol(&_VaultV6.CallOpts)
}

// TotalSupply is a free data retrieval call binding the contract method 0x18160ddd.
//
// Solidity: function totalSupply() view returns(uint256)
func (_VaultV6 *VaultV6Caller) TotalSupply(opts *bind.CallOpts) (*big.Int, error) {
	var out []interface{}
	err := _VaultV6.contract.Call(opts, &out, "totalSupply")

	if err != nil {
		return *new(*big.Int), err
	}

	out0 := *abi.ConvertType(out[0], new(*big.Int)).(**big.Int)

	return out0, err

}

// TotalSupply is a free data retrieval call binding the contract method 0x18160ddd.
//
// Solidity: function totalSupply() view returns(uint256)
func (_VaultV6 *VaultV6Session) TotalSupply() (*big.Int, error) {
	return _VaultV6.Contract.TotalSupply(&_VaultV6.CallOpts)
}

// TotalSupply is a free data retrieval call binding the contract method 0x18160ddd.
//
// Solidity: function totalSupply() view returns(uint256)
func (_VaultV6 *VaultV6CallerSession) TotalSupply() (*big.Int, error) {
	return _VaultV6.Contract.TotalSupply(&_VaultV6.CallOpts)
}

// Want is a free data retrieval call binding the contract method 0x1f1fcd51.
//
// Solidity: function want() view returns(address)
func (_VaultV6 *VaultV6Caller) Want(opts *bind.CallOpts) (common.Address, error) {
	var out []interface{}
	err := _VaultV6.contract.Call(opts, &out, "want")

	if err != nil {
		return *new(common.Address), err
	}

	out0 := *abi.ConvertType(out[0], new(common.Address)).(*common.Address)

	return out0, err

}

// Want is a free data retrieval call binding the contract method 0x1f1fcd51.
//
// Solidity: function want() view returns(address)
func (_VaultV6 *VaultV6Session) Want() (common.Address, error) {
	return _VaultV6.Contract.Want(&_VaultV6.CallOpts)
}

// Want is a free data retrieval call binding the contract method 0x1f1fcd51.
//
// Solidity: function want() view returns(address)
func (_VaultV6 *VaultV6CallerSession) Want() (common.Address, error) {
	return _VaultV6.Contract.Want(&_VaultV6.CallOpts)
}

// Approve is a paid mutator transaction binding the contract method 0x095ea7b3.
//
// Solidity: function approve(address spender, uint256 amount) returns(bool)
func (_VaultV6 *VaultV6Transactor) Approve(opts *bind.TransactOpts, spender common.Address, amount *big.Int) (*types.Transaction, error) {
	return _VaultV6.contract.Transact(opts, "approve", spender, amount)
}

// Approve is a paid mutator transaction binding the contract method 0x095ea7b3.
//
// Solidity: function approve(address spender, uint256 amount) returns(bool)
func (_VaultV6 *VaultV6Session) Approve(spender common.Address, amount *big.Int) (*types.Transaction, error) {
	return _VaultV6.Contract.Approve(&_VaultV6.TransactOpts, spender, amount)
}

// Approve is a paid mutator transaction binding the contract method 0x095ea7b3.
//
// Solidity: function approve(address spender, uint256 amount) returns(bool)
func (_VaultV6 *VaultV6TransactorSession) Approve(spender common.Address, amount *big.Int) (*types.Transaction, error) {
	return _VaultV6.Contract.Approve(&_VaultV6.TransactOpts, spender, amount)
}

// DecreaseAllowance is a paid mutator transaction binding the contract method 0xa457c2d7.
//
// Solidity: function decreaseAllowance(address spender, uint256 subtractedValue) returns(bool)
func (_VaultV6 *VaultV6Transactor) DecreaseAllowance(opts *bind.TransactOpts, spender common.Address, subtractedValue *big.Int) (*types.Transaction, error) {
	return _VaultV6.contract.Transact(opts, "decreaseAllowance", spender, subtractedValue)
}

// DecreaseAllowance is a paid mutator transaction binding the contract method 0xa457c2d7.
//
// Solidity: function decreaseAllowance(address spender, uint256 subtractedValue) returns(bool)
func (_VaultV6 *VaultV6Session) DecreaseAllowance(spender common.Address, subtractedValue *big.Int) (*types.Transaction, error) {
	return _VaultV6.Contract.DecreaseAllowance(&_VaultV6.TransactOpts, spender, subtractedValue)
}

// DecreaseAllowance is a paid mutator transaction binding the contract method 0xa457c2d7.
//
// Solidity: function decreaseAllowance(address spender, uint256 subtractedValue) returns(bool)
func (_VaultV6 *VaultV6TransactorSession) DecreaseAllowance(spender common.Address, subtractedValue *big.Int) (*types.Transaction, error) {
	return _VaultV6.Contract.DecreaseAllowance(&_VaultV6.TransactOpts, spender, subtractedValue)
}

// Deposit is a paid mutator transaction binding the contract method 0xb6b55f25.
//
// Solidity: function deposit(uint256 _amount) returns()
func (_VaultV6 *VaultV6Transactor) Deposit(opts *bind.TransactOpts, _amount *big.Int) (*types.Transaction, error) {
	return _VaultV6.contract.Transact(opts, "deposit", _amount)
}

// Deposit is a paid mutator transaction binding the contract method 0xb6b55f25.
//
// Solidity: function deposit(uint256 _amount) returns()
func (_VaultV6 *VaultV6Session) Deposit(_amount *big.Int) (*types.Transaction, error) {
	return _VaultV6.Contract.Deposit(&_VaultV6.TransactOpts, _amount)
}

// Deposit is a paid mutator transaction binding the contract method 0xb6b55f25.
//
// Solidity: function deposit(uint256 _amount) returns()
func (_VaultV6 *VaultV6TransactorSession) Deposit(_amount *big.Int) (*types.Transaction, error) {
	return _VaultV6.Contract.Deposit(&_VaultV6.TransactOpts, _amount)
}

// DepositAll is a paid mutator transaction binding the contract method 0xde5f6268.
//
// Solidity: function depositAll() returns()
func (_VaultV6 *VaultV6Transactor) DepositAll(opts *bind.TransactOpts) (*types.Transaction, error) {
	return _VaultV6.contract.Transact(opts, "depositAll")
}

// DepositAll is a paid mutator transaction binding the contract method 0xde5f6268.
//
// Solidity: function depositAll() returns()
func (_VaultV6 *VaultV6Session) DepositAll() (*types.Transaction, error) {
	return _VaultV6.Contract.DepositAll(&_VaultV6.TransactOpts)
}

// DepositAll is a paid mutator transaction binding the contract method 0xde5f6268.
//
// Solidity: function depositAll() returns()
func (_VaultV6 *VaultV6TransactorSession) DepositAll() (*types.Transaction, error) {
	return _VaultV6.Contract.DepositAll(&_VaultV6.TransactOpts)
}

// Earn is a paid mutator transaction binding the contract method 0xd389800f.
//
// Solidity: function earn() returns()
func (_VaultV6 *VaultV6Transactor) Earn(opts *bind.TransactOpts) (*types.Transaction, error) {
	return _VaultV6.contract.Transact(opts, "earn")
}

// Earn is a paid mutator transaction binding the contract method 0xd389800f.
//
// Solidity: function earn() returns()
func (_VaultV6 *VaultV6Session) Earn() (*types.Transaction, error) {
	return _VaultV6.Contract.Earn(&_VaultV6.TransactOpts)
}

// Earn is a paid mutator transaction binding the contract method 0xd389800f.
//
// Solidity: function earn() returns()
func (_VaultV6 *VaultV6TransactorSession) Earn() (*types.Transaction, error) {
	return _VaultV6.Contract.Earn(&_VaultV6.TransactOpts)
}

// InCaseTokensGetStuck is a paid mutator transaction binding the contract method 0xdef68a9c.
//
// Solidity: function inCaseTokensGetStuck(address _token) returns()
func (_VaultV6 *VaultV6Transactor) InCaseTokensGetStuck(opts *bind.TransactOpts, _token common.Address) (*types.Transaction, error) {
	return _VaultV6.contract.Transact(opts, "inCaseTokensGetStuck", _token)
}

// InCaseTokensGetStuck is a paid mutator transaction binding the contract method 0xdef68a9c.
//
// Solidity: function inCaseTokensGetStuck(address _token) returns()
func (_VaultV6 *VaultV6Session) InCaseTokensGetStuck(_token common.Address) (*types.Transaction, error) {
	return _VaultV6.Contract.InCaseTokensGetStuck(&_VaultV6.TransactOpts, _token)
}

// InCaseTokensGetStuck is a paid mutator transaction binding the contract method 0xdef68a9c.
//
// Solidity: function inCaseTokensGetStuck(address _token) returns()
func (_VaultV6 *VaultV6TransactorSession) InCaseTokensGetStuck(_token common.Address) (*types.Transaction, error) {
	return _VaultV6.Contract.InCaseTokensGetStuck(&_VaultV6.TransactOpts, _token)
}

// IncreaseAllowance is a paid mutator transaction binding the contract method 0x39509351.
//
// Solidity: function increaseAllowance(address spender, uint256 addedValue) returns(bool)
func (_VaultV6 *VaultV6Transactor) IncreaseAllowance(opts *bind.TransactOpts, spender common.Address, addedValue *big.Int) (*types.Transaction, error) {
	return _VaultV6.contract.Transact(opts, "increaseAllowance", spender, addedValue)
}

// IncreaseAllowance is a paid mutator transaction binding the contract method 0x39509351.
//
// Solidity: function increaseAllowance(address spender, uint256 addedValue) returns(bool)
func (_VaultV6 *VaultV6Session) IncreaseAllowance(spender common.Address, addedValue *big.Int) (*types.Transaction, error) {
	return _VaultV6.Contract.IncreaseAllowance(&_VaultV6.TransactOpts, spender, addedValue)
}

// IncreaseAllowance is a paid mutator transaction binding the contract method 0x39509351.
//
// Solidity: function increaseAllowance(address spender, uint256 addedValue) returns(bool)
func (_VaultV6 *VaultV6TransactorSession) IncreaseAllowance(spender common.Address, addedValue *big.Int) (*types.Transaction, error) {
	return _VaultV6.Contract.IncreaseAllowance(&_VaultV6.TransactOpts, spender, addedValue)
}

// ProposeStrat is a paid mutator transaction binding the contract method 0x5b12ff9b.
//
// Solidity: function proposeStrat(address _implementation) returns()
func (_VaultV6 *VaultV6Transactor) ProposeStrat(opts *bind.TransactOpts, _implementation common.Address) (*types.Transaction, error) {
	return _VaultV6.contract.Transact(opts, "proposeStrat", _implementation)
}

// ProposeStrat is a paid mutator transaction binding the contract method 0x5b12ff9b.
//
// Solidity: function proposeStrat(address _implementation) returns()
func (_VaultV6 *VaultV6Session) ProposeStrat(_implementation common.Address) (*types.Transaction, error) {
	return _VaultV6.Contract.ProposeStrat(&_VaultV6.TransactOpts, _implementation)
}

// ProposeStrat is a paid mutator transaction binding the contract method 0x5b12ff9b.
//
// Solidity: function proposeStrat(address _implementation) returns()
func (_VaultV6 *VaultV6TransactorSession) ProposeStrat(_implementation common.Address) (*types.Transaction, error) {
	return _VaultV6.Contract.ProposeStrat(&_VaultV6.TransactOpts, _implementation)
}

// RenounceOwnership is a paid mutator transaction binding the contract method 0x715018a6.
//
// Solidity: function renounceOwnership() returns()
func (_VaultV6 *VaultV6Transactor) RenounceOwnership(opts *bind.TransactOpts) (*types.Transaction, error) {
	return _VaultV6.contract.Transact(opts, "renounceOwnership")
}

// RenounceOwnership is a paid mutator transaction binding the contract method 0x715018a6.
//
// Solidity: function renounceOwnership() returns()
func (_VaultV6 *VaultV6Session) RenounceOwnership() (*types.Transaction, error) {
	return _VaultV6.Contract.RenounceOwnership(&_VaultV6.TransactOpts)
}

// RenounceOwnership is a paid mutator transaction binding the contract method 0x715018a6.
//
// Solidity: function renounceOwnership() returns()
func (_VaultV6 *VaultV6TransactorSession) RenounceOwnership() (*types.Transaction, error) {
	return _VaultV6.Contract.RenounceOwnership(&_VaultV6.TransactOpts)
}

// Transfer is a paid mutator transaction binding the contract method 0xa9059cbb.
//
// Solidity: function transfer(address recipient, uint256 amount) returns(bool)
func (_VaultV6 *VaultV6Transactor) Transfer(opts *bind.TransactOpts, recipient common.Address, amount *big.Int) (*types.Transaction, error) {
	return _VaultV6.contract.Transact(opts, "transfer", recipient, amount)
}

// Transfer is a paid mutator transaction binding the contract method 0xa9059cbb.
//
// Solidity: function transfer(address recipient, uint256 amount) returns(bool)
func (_VaultV6 *VaultV6Session) Transfer(recipient common.Address, amount *big.Int) (*types.Transaction, error) {
	return _VaultV6.Contract.Transfer(&_VaultV6.TransactOpts, recipient, amount)
}

// Transfer is a paid mutator transaction binding the contract method 0xa9059cbb.
//
// Solidity: function transfer(address recipient, uint256 amount) returns(bool)
func (_VaultV6 *VaultV6TransactorSession) Transfer(recipient common.Address, amount *big.Int) (*types.Transaction, error) {
	return _VaultV6.Contract.Transfer(&_VaultV6.TransactOpts, recipient, amount)
}

// TransferFrom is a paid mutator transaction binding the contract method 0x23b872dd.
//
// Solidity: function transferFrom(address sender, address recipient, uint256 amount) returns(bool)
func (_VaultV6 *VaultV6Transactor) TransferFrom(opts *bind.TransactOpts, sender common.Address, recipient common.Address, amount *big.Int) (*types.Transaction, error) {
	return _VaultV6.contract.Transact(opts, "transferFrom", sender, recipient, amount)
}

// TransferFrom is a paid mutator transaction binding the contract method 0x23b872dd.
//
// Solidity: function transferFrom(address sender, address recipient, uint256 amount) returns(bool)
func (_VaultV6 *VaultV6Session) TransferFrom(sender common.Address, recipient common.Address, amount *big.Int) (*types.Transaction, error) {
	return _VaultV6.Contract.TransferFrom(&_VaultV6.TransactOpts, sender, recipient, amount)
}

// TransferFrom is a paid mutator transaction binding the contract method 0x23b872dd.
//
// Solidity: function transferFrom(address sender, address recipient, uint256 amount) returns(bool)
func (_VaultV6 *VaultV6TransactorSession) TransferFrom(sender common.Address, recipient common.Address, amount *big.Int) (*types.Transaction, error) {
	return _VaultV6.Contract.TransferFrom(&_VaultV6.TransactOpts, sender, recipient, amount)
}

// TransferOwnership is a paid mutator transaction binding the contract method 0xf2fde38b.
//
// Solidity: function transferOwnership(address newOwner) returns()
func (_VaultV6 *VaultV6Transactor) TransferOwnership(opts *bind.TransactOpts, newOwner common.Address) (*types.Transaction, error) {
	return _VaultV6.contract.Transact(opts, "transferOwnership", newOwner)
}

// TransferOwnership is a paid mutator transaction binding the contract method 0xf2fde38b.
//
// Solidity: function transferOwnership(address newOwner) returns()
func (_VaultV6 *VaultV6Session) TransferOwnership(newOwner common.Address) (*types.Transaction, error) {
	return _VaultV6.Contract.TransferOwnership(&_VaultV6.TransactOpts, newOwner)
}

// TransferOwnership is a paid mutator transaction binding the contract method 0xf2fde38b.
//
// Solidity: function transferOwnership(address newOwner) returns()
func (_VaultV6 *VaultV6TransactorSession) TransferOwnership(newOwner common.Address) (*types.Transaction, error) {
	return _VaultV6.Contract.TransferOwnership(&_VaultV6.TransactOpts, newOwner)
}

// UpgradeStrat is a paid mutator transaction binding the contract method 0xe6685244.
//
// Solidity: function upgradeStrat() returns()
func (_VaultV6 *VaultV6Transactor) UpgradeStrat(opts *bind.TransactOpts) (*types.Transaction, error) {
	return _VaultV6.contract.Transact(opts, "upgradeStrat")
}

// UpgradeStrat is a paid mutator transaction binding the contract method 0xe6685244.
//
// Solidity: function upgradeStrat() returns()
func (_VaultV6 *VaultV6Session) UpgradeStrat() (*types.Transaction, error) {
	return _VaultV6.Contract.UpgradeStrat(&_VaultV6.TransactOpts)
}

// UpgradeStrat is a paid mutator transaction binding the contract method 0xe6685244.
//
// Solidity: function upgradeStrat() returns()
func (_VaultV6 *VaultV6TransactorSession) UpgradeStrat() (*types.Transaction, error) {
	return _VaultV6.Contract.UpgradeStrat(&_VaultV6.TransactOpts)
}

// Withdraw is a paid mutator transaction binding the contract method 0x2e1a7d4d.
//
// Solidity: function withdraw(uint256 _shares) returns()
func (_VaultV6 *VaultV6Transactor) Withdraw(opts *bind.TransactOpts, _shares *big.Int) (*types.Transaction, error) {
	return _VaultV6.contract.Transact(opts, "withdraw", _shares)
}

// Withdraw is a paid mutator transaction binding the contract method 0x2e1a7d4d.
//
// Solidity: function withdraw(uint256 _shares) returns()
func (_VaultV6 *VaultV6Session) Withdraw(_shares *big.Int) (*types.Transaction, error) {
	return _VaultV6.Contract.Withdraw(&_VaultV6.TransactOpts, _shares)
}

// Withdraw is a paid mutator transaction binding the contract method 0x2e1a7d4d.
//
// Solidity: function withdraw(uint256 _shares) returns()
func (_VaultV6 *VaultV6TransactorSession) Withdraw(_shares *big.Int) (*types.Transaction, error) {
	return _VaultV6.Contract.Withdraw(&_VaultV6.TransactOpts, _shares)
}

// WithdrawAll is a paid mutator transaction binding the contract method 0x853828b6.
//
// Solidity: function withdrawAll() returns()
func (_VaultV6 *VaultV6Transactor) WithdrawAll(opts *bind.TransactOpts) (*types.Transaction, error) {
	return _VaultV6.contract.Transact(opts, "withdrawAll")
}

// WithdrawAll is a paid mutator transaction binding the contract method 0x853828b6.
//
// Solidity: function withdrawAll() returns()
func (_VaultV6 *VaultV6Session) WithdrawAll() (*types.Transaction, error) {
	return _VaultV6.Contract.WithdrawAll(&_VaultV6.TransactOpts)
}

// WithdrawAll is a paid mutator transaction binding the contract method 0x853828b6.
//
// Solidity: function withdrawAll() returns()
func (_VaultV6 *VaultV6TransactorSession) WithdrawAll() (*types.Transaction, error) {
	return _VaultV6.Contract.WithdrawAll(&_VaultV6.TransactOpts)
}

// VaultV6ApprovalIterator is returned from FilterApproval and is used to iterate over the raw logs and unpacked data for Approval events raised by the VaultV6 contract.
type VaultV6ApprovalIterator struct {
	Event *VaultV6Approval // Event containing the contract specifics and raw log

	contract *bind.BoundContract // Generic contract to use for unpacking event data
	event    string              // Event name to use for unpacking event data

	logs chan types.Log        // Log channel receiving the found contract events
	sub  ethereum.Subscription // Subscription for errors, completion and termination
	done bool                  // Whether the subscription completed delivering logs
	fail error                 // Occurred error to stop iteration
}

// Next advances the iterator to the subsequent event, returning whether there
// are any more events found. In case of a retrieval or parsing error, false is
// returned and Error() can be queried for the exact failure.
func (it *VaultV6ApprovalIterator) Next() bool {
	// If the iterator failed, stop iterating
	if it.fail != nil {
		return false
	}
	// If the iterator completed, deliver directly whatever's available
	if it.done {
		select {
		case log := <-it.logs:
			it.Event = new(VaultV6Approval)
			if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
				it.fail = err
				return false
			}
			it.Event.Raw = log
			return true

		default:
			return false
		}
	}
	// Iterator still in progress, wait for either a data or an error event
	select {
	case log := <-it.logs:
		it.Event = new(VaultV6Approval)
		if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
			it.fail = err
			return false
		}
		it.Event.Raw = log
		return true

	case err := <-it.sub.Err():
		it.done = true
		it.fail = err
		return it.Next()
	}
}

// Error returns any retrieval or parsing error occurred during filtering.
func (it *VaultV6ApprovalIterator) Error() error {
	return it.fail
}

// Close terminates the iteration process, releasing any pending underlying
// resources.
func (it *VaultV6ApprovalIterator) Close() error {
	it.sub.Unsubscribe()
	return nil
}

// VaultV6Approval represents a Approval event raised by the VaultV6 contract.
type VaultV6Approval struct {
	Owner   common.Address
	Spender common.Address
	Value   *big.Int
	Raw     types.Log // Blockchain specific contextual infos
}

// FilterApproval is a free log retrieval operation binding the contract event 0x8c5be1e5ebec7d5bd14f71427d1e84f3dd0314c0f7b2291e5b200ac8c7c3b925.
//
// Solidity: event Approval(address indexed owner, address indexed spender, uint256 value)
func (_VaultV6 *VaultV6Filterer) FilterApproval(opts *bind.FilterOpts, owner []common.Address, spender []common.Address) (*VaultV6ApprovalIterator, error) {

	var ownerRule []interface{}
	for _, ownerItem := range owner {
		ownerRule = append(ownerRule, ownerItem)
	}
	var spenderRule []interface{}
	for _, spenderItem := range spender {
		spenderRule = append(spenderRule, spenderItem)
	}

	logs, sub, err := _VaultV6.contract.FilterLogs(opts, "Approval", ownerRule, spenderRule)
	if err != nil {
		return nil, err
	}
	return &VaultV6ApprovalIterator{contract: _VaultV6.contract, event: "Approval", logs: logs, sub: sub}, nil
}

// WatchApproval is a free log subscription operation binding the contract event 0x8c5be1e5ebec7d5bd14f71427d1e84f3dd0314c0f7b2291e5b200ac8c7c3b925.
//
// Solidity: event Approval(address indexed owner, address indexed spender, uint256 value)
func (_VaultV6 *VaultV6Filterer) WatchApproval(opts *bind.WatchOpts, sink chan<- *VaultV6Approval, owner []common.Address, spender []common.Address) (event.Subscription, error) {

	var ownerRule []interface{}
	for _, ownerItem := range owner {
		ownerRule = append(ownerRule, ownerItem)
	}
	var spenderRule []interface{}
	for _, spenderItem := range spender {
		spenderRule = append(spenderRule, spenderItem)
	}

	logs, sub, err := _VaultV6.contract.WatchLogs(opts, "Approval", ownerRule, spenderRule)
	if err != nil {
		return nil, err
	}
	return event.NewSubscription(func(quit <-chan struct{}) error {
		defer sub.Unsubscribe()
		for {
			select {
			case log := <-logs:
				// New log arrived, parse the event and forward to the user
				event := new(VaultV6Approval)
				if err := _VaultV6.contract.UnpackLog(event, "Approval", log); err != nil {
					return err
				}
				event.Raw = log

				select {
				case sink <- event:
				case err := <-sub.Err():
					return err
				case <-quit:
					return nil
				}
			case err := <-sub.Err():
				return err
			case <-quit:
				return nil
			}
		}
	}), nil
}

// ParseApproval is a log parse operation binding the contract event 0x8c5be1e5ebec7d5bd14f71427d1e84f3dd0314c0f7b2291e5b200ac8c7c3b925.
//
// Solidity: event Approval(address indexed owner, address indexed spender, uint256 value)
func (_VaultV6 *VaultV6Filterer) ParseApproval(log types.Log) (*VaultV6Approval, error) {
	event := new(VaultV6Approval)
	if err := _VaultV6.contract.UnpackLog(event, "Approval", log); err != nil {
		return nil, err
	}
	event.Raw = log
	return event, nil
}

// VaultV6NewStratCandidateIterator is returned from FilterNewStratCandidate and is used to iterate over the raw logs and unpacked data for NewStratCandidate events raised by the VaultV6 contract.
type VaultV6NewStratCandidateIterator struct {
	Event *VaultV6NewStratCandidate // Event containing the contract specifics and raw log

	contract *bind.BoundContract // Generic contract to use for unpacking event data
	event    string              // Event name to use for unpacking event data

	logs chan types.Log        // Log channel receiving the found contract events
	sub  ethereum.Subscription // Subscription for errors, completion and termination
	done bool                  // Whether the subscription completed delivering logs
	fail error                 // Occurred error to stop iteration
}

// Next advances the iterator to the subsequent event, returning whether there
// are any more events found. In case of a retrieval or parsing error, false is
// returned and Error() can be queried for the exact failure.
func (it *VaultV6NewStratCandidateIterator) Next() bool {
	// If the iterator failed, stop iterating
	if it.fail != nil {
		return false
	}
	// If the iterator completed, deliver directly whatever's available
	if it.done {
		select {
		case log := <-it.logs:
			it.Event = new(VaultV6NewStratCandidate)
			if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
				it.fail = err
				return false
			}
			it.Event.Raw = log
			return true

		default:
			return false
		}
	}
	// Iterator still in progress, wait for either a data or an error event
	select {
	case log := <-it.logs:
		it.Event = new(VaultV6NewStratCandidate)
		if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
			it.fail = err
			return false
		}
		it.Event.Raw = log
		return true

	case err := <-it.sub.Err():
		it.done = true
		it.fail = err
		return it.Next()
	}
}

// Error returns any retrieval or parsing error occurred during filtering.
func (it *VaultV6NewStratCandidateIterator) Error() error {
	return it.fail
}

// Close terminates the iteration process, releasing any pending underlying
// resources.
func (it *VaultV6NewStratCandidateIterator) Close() error {
	it.sub.Unsubscribe()
	return nil
}

// VaultV6NewStratCandidate represents a NewStratCandidate event raised by the VaultV6 contract.
type VaultV6NewStratCandidate struct {
	Implementation common.Address
	Raw            types.Log // Blockchain specific contextual infos
}

// FilterNewStratCandidate is a free log retrieval operation binding the contract event 0x1aae2ec5647db56da2d513de40528ba3565c6057525637050660c4323bbac7df.
//
// Solidity: event NewStratCandidate(address implementation)
func (_VaultV6 *VaultV6Filterer) FilterNewStratCandidate(opts *bind.FilterOpts) (*VaultV6NewStratCandidateIterator, error) {

	logs, sub, err := _VaultV6.contract.FilterLogs(opts, "NewStratCandidate")
	if err != nil {
		return nil, err
	}
	return &VaultV6NewStratCandidateIterator{contract: _VaultV6.contract, event: "NewStratCandidate", logs: logs, sub: sub}, nil
}

// WatchNewStratCandidate is a free log subscription operation binding the contract event 0x1aae2ec5647db56da2d513de40528ba3565c6057525637050660c4323bbac7df.
//
// Solidity: event NewStratCandidate(address implementation)
func (_VaultV6 *VaultV6Filterer) WatchNewStratCandidate(opts *bind.WatchOpts, sink chan<- *VaultV6NewStratCandidate) (event.Subscription, error) {

	logs, sub, err := _VaultV6.contract.WatchLogs(opts, "NewStratCandidate")
	if err != nil {
		return nil, err
	}
	return event.NewSubscription(func(quit <-chan struct{}) error {
		defer sub.Unsubscribe()
		for {
			select {
			case log := <-logs:
				// New log arrived, parse the event and forward to the user
				event := new(VaultV6NewStratCandidate)
				if err := _VaultV6.contract.UnpackLog(event, "NewStratCandidate", log); err != nil {
					return err
				}
				event.Raw = log

				select {
				case sink <- event:
				case err := <-sub.Err():
					return err
				case <-quit:
					return nil
				}
			case err := <-sub.Err():
				return err
			case <-quit:
				return nil
			}
		}
	}), nil
}

// ParseNewStratCandidate is a log parse operation binding the contract event 0x1aae2ec5647db56da2d513de40528ba3565c6057525637050660c4323bbac7df.
//
// Solidity: event NewStratCandidate(address implementation)
func (_VaultV6 *VaultV6Filterer) ParseNewStratCandidate(log types.Log) (*VaultV6NewStratCandidate, error) {
	event := new(VaultV6NewStratCandidate)
	if err := _VaultV6.contract.UnpackLog(event, "NewStratCandidate", log); err != nil {
		return nil, err
	}
	event.Raw = log
	return event, nil
}

// VaultV6OwnershipTransferredIterator is returned from FilterOwnershipTransferred and is used to iterate over the raw logs and unpacked data for OwnershipTransferred events raised by the VaultV6 contract.
type VaultV6OwnershipTransferredIterator struct {
	Event *VaultV6OwnershipTransferred // Event containing the contract specifics and raw log

	contract *bind.BoundContract // Generic contract to use for unpacking event data
	event    string              // Event name to use for unpacking event data

	logs chan types.Log        // Log channel receiving the found contract events
	sub  ethereum.Subscription // Subscription for errors, completion and termination
	done bool                  // Whether the subscription completed delivering logs
	fail error                 // Occurred error to stop iteration
}

// Next advances the iterator to the subsequent event, returning whether there
// are any more events found. In case of a retrieval or parsing error, false is
// returned and Error() can be queried for the exact failure.
func (it *VaultV6OwnershipTransferredIterator) Next() bool {
	// If the iterator failed, stop iterating
	if it.fail != nil {
		return false
	}
	// If the iterator completed, deliver directly whatever's available
	if it.done {
		select {
		case log := <-it.logs:
			it.Event = new(VaultV6OwnershipTransferred)
			if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
				it.fail = err
				return false
			}
			it.Event.Raw = log
			return true

		default:
			return false
		}
	}
	// Iterator still in progress, wait for either a data or an error event
	select {
	case log := <-it.logs:
		it.Event = new(VaultV6OwnershipTransferred)
		if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
			it.fail = err
			return false
		}
		it.Event.Raw = log
		return true

	case err := <-it.sub.Err():
		it.done = true
		it.fail = err
		return it.Next()
	}
}

// Error returns any retrieval or parsing error occurred during filtering.
func (it *VaultV6OwnershipTransferredIterator) Error() error {
	return it.fail
}

// Close terminates the iteration process, releasing any pending underlying
// resources.
func (it *VaultV6OwnershipTransferredIterator) Close() error {
	it.sub.Unsubscribe()
	return nil
}

// VaultV6OwnershipTransferred represents a OwnershipTransferred event raised by the VaultV6 contract.
type VaultV6OwnershipTransferred struct {
	PreviousOwner common.Address
	NewOwner      common.Address
	Raw           types.Log // Blockchain specific contextual infos
}

// FilterOwnershipTransferred is a free log retrieval operation binding the contract event 0x8be0079c531659141344cd1fd0a4f28419497f9722a3daafe3b4186f6b6457e0.
//
// Solidity: event OwnershipTransferred(address indexed previousOwner, address indexed newOwner)
func (_VaultV6 *VaultV6Filterer) FilterOwnershipTransferred(opts *bind.FilterOpts, previousOwner []common.Address, newOwner []common.Address) (*VaultV6OwnershipTransferredIterator, error) {

	var previousOwnerRule []interface{}
	for _, previousOwnerItem := range previousOwner {
		previousOwnerRule = append(previousOwnerRule, previousOwnerItem)
	}
	var newOwnerRule []interface{}
	for _, newOwnerItem := range newOwner {
		newOwnerRule = append(newOwnerRule, newOwnerItem)
	}

	logs, sub, err := _VaultV6.contract.FilterLogs(opts, "OwnershipTransferred", previousOwnerRule, newOwnerRule)
	if err != nil {
		return nil, err
	}
	return &VaultV6OwnershipTransferredIterator{contract: _VaultV6.contract, event: "OwnershipTransferred", logs: logs, sub: sub}, nil
}

// WatchOwnershipTransferred is a free log subscription operation binding the contract event 0x8be0079c531659141344cd1fd0a4f28419497f9722a3daafe3b4186f6b6457e0.
//
// Solidity: event OwnershipTransferred(address indexed previousOwner, address indexed newOwner)
func (_VaultV6 *VaultV6Filterer) WatchOwnershipTransferred(opts *bind.WatchOpts, sink chan<- *VaultV6OwnershipTransferred, previousOwner []common.Address, newOwner []common.Address) (event.Subscription, error) {

	var previousOwnerRule []interface{}
	for _, previousOwnerItem := range previousOwner {
		previousOwnerRule = append(previousOwnerRule, previousOwnerItem)
	}
	var newOwnerRule []interface{}
	for _, newOwnerItem := range newOwner {
		newOwnerRule = append(newOwnerRule, newOwnerItem)
	}

	logs, sub, err := _VaultV6.contract.WatchLogs(opts, "OwnershipTransferred", previousOwnerRule, newOwnerRule)
	if err != nil {
		return nil, err
	}
	return event.NewSubscription(func(quit <-chan struct{}) error {
		defer sub.Unsubscribe()
		for {
			select {
			case log := <-logs:
				// New log arrived, parse the event and forward to the user
				event := new(VaultV6OwnershipTransferred)
				if err := _VaultV6.contract.UnpackLog(event, "OwnershipTransferred", log); err != nil {
					return err
				}
				event.Raw = log

				select {
				case sink <- event:
				case err := <-sub.Err():
					return err
				case <-quit:
					return nil
				}
			case err := <-sub.Err():
				return err
			case <-quit:
				return nil
			}
		}
	}), nil
}

// ParseOwnershipTransferred is a log parse operation binding the contract event 0x8be0079c531659141344cd1fd0a4f28419497f9722a3daafe3b4186f6b6457e0.
//
// Solidity: event OwnershipTransferred(address indexed previousOwner, address indexed newOwner)
func (_VaultV6 *VaultV6Filterer) ParseOwnershipTransferred(log types.Log) (*VaultV6OwnershipTransferred, error) {
	event := new(VaultV6OwnershipTransferred)
	if err := _VaultV6.contract.UnpackLog(event, "OwnershipTransferred", log); err != nil {
		return nil, err
	}
	event.Raw = log
	return event, nil
}

// VaultV6TransferIterator is returned from FilterTransfer and is used to iterate over the raw logs and unpacked data for Transfer events raised by the VaultV6 contract.
type VaultV6TransferIterator struct {
	Event *VaultV6Transfer // Event containing the contract specifics and raw log

	contract *bind.BoundContract // Generic contract to use for unpacking event data
	event    string              // Event name to use for unpacking event data

	logs chan types.Log        // Log channel receiving the found contract events
	sub  ethereum.Subscription // Subscription for errors, completion and termination
	done bool                  // Whether the subscription completed delivering logs
	fail error                 // Occurred error to stop iteration
}

// Next advances the iterator to the subsequent event, returning whether there
// are any more events found. In case of a retrieval or parsing error, false is
// returned and Error() can be queried for the exact failure.
func (it *VaultV6TransferIterator) Next() bool {
	// If the iterator failed, stop iterating
	if it.fail != nil {
		return false
	}
	// If the iterator completed, deliver directly whatever's available
	if it.done {
		select {
		case log := <-it.logs:
			it.Event = new(VaultV6Transfer)
			if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
				it.fail = err
				return false
			}
			it.Event.Raw = log
			return true

		default:
			return false
		}
	}
	// Iterator still in progress, wait for either a data or an error event
	select {
	case log := <-it.logs:
		it.Event = new(VaultV6Transfer)
		if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
			it.fail = err
			return false
		}
		it.Event.Raw = log
		return true

	case err := <-it.sub.Err():
		it.done = true
		it.fail = err
		return it.Next()
	}
}

// Error returns any retrieval or parsing error occurred during filtering.
func (it *VaultV6TransferIterator) Error() error {
	return it.fail
}

// Close terminates the iteration process, releasing any pending underlying
// resources.
func (it *VaultV6TransferIterator) Close() error {
	it.sub.Unsubscribe()
	return nil
}

// VaultV6Transfer represents a Transfer event raised by the VaultV6 contract.
type VaultV6Transfer struct {
	From  common.Address
	To    common.Address
	Value *big.Int
	Raw   types.Log // Blockchain specific contextual infos
}

// FilterTransfer is a free log retrieval operation binding the contract event 0xddf252ad1be2c89b69c2b068fc378daa952ba7f163c4a11628f55a4df523b3ef.
//
// Solidity: event Transfer(address indexed from, address indexed to, uint256 value)
func (_VaultV6 *VaultV6Filterer) FilterTransfer(opts *bind.FilterOpts, from []common.Address, to []common.Address) (*VaultV6TransferIterator, error) {

	var fromRule []interface{}
	for _, fromItem := range from {
		fromRule = append(fromRule, fromItem)
	}
	var toRule []interface{}
	for _, toItem := range to {
		toRule = append(toRule, toItem)
	}

	logs, sub, err := _VaultV6.contract.FilterLogs(opts, "Transfer", fromRule, toRule)
	if err != nil {
		return nil, err
	}
	return &VaultV6TransferIterator{contract: _VaultV6.contract, event: "Transfer", logs: logs, sub: sub}, nil
}

// WatchTransfer is a free log subscription operation binding the contract event 0xddf252ad1be2c89b69c2b068fc378daa952ba7f163c4a11628f55a4df523b3ef.
//
// Solidity: event Transfer(address indexed from, address indexed to, uint256 value)
func (_VaultV6 *VaultV6Filterer) WatchTransfer(opts *bind.WatchOpts, sink chan<- *VaultV6Transfer, from []common.Address, to []common.Address) (event.Subscription, error) {

	var fromRule []interface{}
	for _, fromItem := range from {
		fromRule = append(fromRule, fromItem)
	}
	var toRule []interface{}
	for _, toItem := range to {
		toRule = append(toRule, toItem)
	}

	logs, sub, err := _VaultV6.contract.WatchLogs(opts, "Transfer", fromRule, toRule)
	if err != nil {
		return nil, err
	}
	return event.NewSubscription(func(quit <-chan struct{}) error {
		defer sub.Unsubscribe()
		for {
			select {
			case log := <-logs:
				// New log arrived, parse the event and forward to the user
				event := new(VaultV6Transfer)
				if err := _VaultV6.contract.UnpackLog(event, "Transfer", log); err != nil {
					return err
				}
				event.Raw = log

				select {
				case sink <- event:
				case err := <-sub.Err():
					return err
				case <-quit:
					return nil
				}
			case err := <-sub.Err():
				return err
			case <-quit:
				return nil
			}
		}
	}), nil
}

// ParseTransfer is a log parse operation binding the contract event 0xddf252ad1be2c89b69c2b068fc378daa952ba7f163c4a11628f55a4df523b3ef.
//
// Solidity: event Transfer(address indexed from, address indexed to, uint256 value)
func (_VaultV6 *VaultV6Filterer) ParseTransfer(log types.Log) (*VaultV6Transfer, error) {
	event := new(VaultV6Transfer)
	if err := _VaultV6.contract.UnpackLog(event, "Transfer", log); err != nil {
		return nil, err
	}
	event.Raw = log
	return event, nil
}

// VaultV6UpgradeStratIterator is returned from FilterUpgradeStrat and is used to iterate over the raw logs and unpacked data for UpgradeStrat events raised by the VaultV6 contract.
type VaultV6UpgradeStratIterator struct {
	Event *VaultV6UpgradeStrat // Event containing the contract specifics and raw log

	contract *bind.BoundContract // Generic contract to use for unpacking event data
	event    string              // Event name to use for unpacking event data

	logs chan types.Log        // Log channel receiving the found contract events
	sub  ethereum.Subscription // Subscription for errors, completion and termination
	done bool                  // Whether the subscription completed delivering logs
	fail error                 // Occurred error to stop iteration
}

// Next advances the iterator to the subsequent event, returning whether there
// are any more events found. In case of a retrieval or parsing error, false is
// returned and Error() can be queried for the exact failure.
func (it *VaultV6UpgradeStratIterator) Next() bool {
	// If the iterator failed, stop iterating
	if it.fail != nil {
		return false
	}
	// If the iterator completed, deliver directly whatever's available
	if it.done {
		select {
		case log := <-it.logs:
			it.Event = new(VaultV6UpgradeStrat)
			if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
				it.fail = err
				return false
			}
			it.Event.Raw = log
			return true

		default:
			return false
		}
	}
	// Iterator still in progress, wait for either a data or an error event
	select {
	case log := <-it.logs:
		it.Event = new(VaultV6UpgradeStrat)
		if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
			it.fail = err
			return false
		}
		it.Event.Raw = log
		return true

	case err := <-it.sub.Err():
		it.done = true
		it.fail = err
		return it.Next()
	}
}

// Error returns any retrieval or parsing error occurred during filtering.
func (it *VaultV6UpgradeStratIterator) Error() error {
	return it.fail
}

// Close terminates the iteration process, releasing any pending underlying
// resources.
func (it *VaultV6UpgradeStratIterator) Close() error {
	it.sub.Unsubscribe()
	return nil
}

// VaultV6UpgradeStrat represents a UpgradeStrat event raised by the VaultV6 contract.
type VaultV6UpgradeStrat struct {
	Implementation common.Address
	Raw            types.Log // Blockchain specific contextual infos
}

// FilterUpgradeStrat is a free log retrieval operation binding the contract event 0x7f37d440e85aba7fbf641c4bda5ca4ef669a80bffaacde2aa8d9feb1b048c82c.
//
// Solidity: event UpgradeStrat(address implementation)
func (_VaultV6 *VaultV6Filterer) FilterUpgradeStrat(opts *bind.FilterOpts) (*VaultV6UpgradeStratIterator, error) {

	logs, sub, err := _VaultV6.contract.FilterLogs(opts, "UpgradeStrat")
	if err != nil {
		return nil, err
	}
	return &VaultV6UpgradeStratIterator{contract: _VaultV6.contract, event: "UpgradeStrat", logs: logs, sub: sub}, nil
}

// WatchUpgradeStrat is a free log subscription operation binding the contract event 0x7f37d440e85aba7fbf641c4bda5ca4ef669a80bffaacde2aa8d9feb1b048c82c.
//
// Solidity: event UpgradeStrat(address implementation)
func (_VaultV6 *VaultV6Filterer) WatchUpgradeStrat(opts *bind.WatchOpts, sink chan<- *VaultV6UpgradeStrat) (event.Subscription, error) {

	logs, sub, err := _VaultV6.contract.WatchLogs(opts, "UpgradeStrat")
	if err != nil {
		return nil, err
	}
	return event.NewSubscription(func(quit <-chan struct{}) error {
		defer sub.Unsubscribe()
		for {
			select {
			case log := <-logs:
				// New log arrived, parse the event and forward to the user
				event := new(VaultV6UpgradeStrat)
				if err := _VaultV6.contract.UnpackLog(event, "UpgradeStrat", log); err != nil {
					return err
				}
				event.Raw = log

				select {
				case sink <- event:
				case err := <-sub.Err():
					return err
				case <-quit:
					return nil
				}
			case err := <-sub.Err():
				return err
			case <-quit:
				return nil
			}
		}
	}), nil
}

// ParseUpgradeStrat is a log parse operation binding the contract event 0x7f37d440e85aba7fbf641c4bda5ca4ef669a80bffaacde2aa8d9feb1b048c82c.
//
// Solidity: event UpgradeStrat(address implementation)
func (_VaultV6 *VaultV6Filterer) ParseUpgradeStrat(log types.Log) (*VaultV6UpgradeStrat, error) {
	event := new(VaultV6UpgradeStrat)
	if err := _VaultV6.contract.UnpackLog(event, "UpgradeStrat", log); err != nil {
		return nil, err
	}
	event.Raw = log
	return event, nil
}
